
#ifndef HH_DEFAULT_HANDLER
#define HH_DEFAULT_HANDLER

#include "async.hh"
#include "flow_handler.hh"

#include <cerrno>
#include <fcntl.h>
#include <unistd.h>

using namespace std;

class default_handler : public flow_handler, async
{
private:
    int fd;

    enum {
	NONE,
	BOUND,
	LISTENING,
	LISTENING_AVAIL,
	CONNECTING,
	CONNECTED,
	STOP_READING,
	CLOSED
    } state;

    string buffer;

    bool write_shutdown;

public:
    default_handler(init_context& ctxt, int _fd = -1);

    void ravail();
    void wavail();

    bool avail(flow_handler *from, data d);
    int connect(address a);
    int bind(address a);
    acceptret accept();
    int close();
    int write(data d);
    int shutdown(bool r, bool w);
    int listen(int backlog);
    address getsockname();
    address getpeername();
    string getsockopt(int level, int optname, int maxlen);
    int setsockopt(int level, int optname, string value);

    void may_avail(bool may);
};

#endif
